'From Squeak3.1alpha of 7 March 2001 [latest update: #4173] on 1 August 2001 at 1:25:13 am'!

!Object methodsFor: 'morphic wrappers' stamp: 'fg 7/15/2001 02:48'!
hasNiceWrapper
	^ false! !

!Object methodsFor: 'morphic wrappers' stamp: 'fg 7/31/2001 01:44'!
wrapAndAttachTo: hnd
	^ self hasNiceWrapper 
		ifTrue: [hnd attachMorph: self asMorph]
		ifFalse: [self explore]
! !


!Behavior methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!Boolean methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!Character methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!CompiledMethod methodsFor: 'morphic wrapper' stamp: 'fg 8/1/2001 01:23'!
hasNiceWrapper
	^ true! !


!Date methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!ListItemWrapper methodsFor: 'as yet unclassified' stamp: 'fg 10/29/1999 12:44'!
item
	^ item! !


!MethodModel methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!Morph methodsFor: 'morphic wrappers' stamp: 'fg 7/31/2001 01:49'!
acceptBalloon: aCodeBalloon 
	| fail result hnd morph |
	hnd _ aCodeBalloon target.
	aCodeBalloon delete.
	fail _ Object new.
	result _ Compiler new
				evaluate: aCodeBalloon string intendedMessage
				in: nil
				to: self receiver
				notifying: aCodeBalloon string
				ifFail: [fail].
	result == fail
		ifTrue: 
			[hnd attachMorph: aCodeBalloon;
			 newKeyboardFocus: aCodeBalloon]
		ifFalse: 
			[morph _ result asMorph.
			aCodeBalloon target newKeyboardFocus: nil.
			aCodeBalloon contents withBlanksTrimmed last = $.
				ifFalse: [morph == self
						ifTrue: [self shake]
						ifFalse: [result wrapAndAttachTo: hnd]]]! !

!Morph methodsFor: 'morphic wrappers' stamp: 'fg 7/15/2001 02:57'!
hasNiceWrapper
	^ true! !

!Morph methodsFor: 'morphic wrappers' stamp: 'fg 7/15/2001 02:05'!
wrapee
	"I am not wrapping anyone, so I answer myself"
	^ self! !


!IndentingListItemMorph methodsFor: 'mouse events' stamp: 'fg 8/1/2001 00:35'!
handlesMouseOver: evt
	^ true! !

!IndentingListItemMorph methodsFor: 'mouse events' stamp: 'fg 8/1/2001 00:47'!
mouseEnter: evt
	container mouseEnter: evt onItem: self.
	self changed
	! !


!Number methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true
! !


!ObjectExplorer methodsFor: 'as yet unclassified' stamp: 'fg 4/17/2001 00:58'!
explorerFor: anObject
	| window listMorph |
	rootObject _ anObject.
	window _ (SystemWindow labelled: 'Explorer') model: self.
	window addMorph: (listMorph _ SimpleHierarchicalListMorph 
			on: self
			list: #getList
			selected: #getCurrentSelection
			changeSelected: #noteNewSelection:
			menu: #genericMenu:
			keystroke: nil)
		frame: (0@0 corner: 1@1).
	listMorph autoDeselect: false.
     ^ window! !

!ObjectExplorer methodsFor: 'as yet unclassified' stamp: 'fg 7/14/2001 21:42'!
initialExtent

	^300@300! !


!Point methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:42'!
hasNiceWrapper
	^ true! !


!SimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'fg 8/1/2001 00:40'!
drawOn: aCanvas
	super drawOn: aCanvas.
	"
	selectedMorph ifNotNil:
		[aCanvas fillRectangle:
			(((scroller transformFrom: self) invertBoundsRect: selectedMorph bounds)
						intersect: scroller bounds)
				color: color darker]
	"! !

!SimpleHierarchicalListMorph methodsFor: 'events' stamp: 'fg 8/1/2001 00:42'!
mouseEnter: event onItem: aMorph
	self setSelectedMorph: aMorph! !

!SimpleHierarchicalListMorph methodsFor: 'model access' stamp: 'fg 7/14/2001 22:51'!
itemKeyStroke: event
	"MorphicWrapper keyStroke handling"

	| currentSelection mw balloon |
	currentSelection _ self model getCurrentSelection.
	currentSelection isNil ifTrue: [^ nil].
	mw _ currentSelection item asMorph.
	balloon _ CodeBalloonMorph for: mw hand: event hand.
	^ balloon keyStroke: event! !

!SimpleHierarchicalListMorph methodsFor: 'model access' stamp: 'fg 7/14/2001 22:29'!
keyStroke: event 
	"Process potential command keys"
	| args aCharacter |
	(self scrollByKeyboard: event)
		ifTrue: [^ self].
	keystrokeActionSelector == nil ifTrue: [^ self itemKeyStroke: event].
	aCharacter _ event keyCharacter.
	(args _ keystrokeActionSelector numArgs) = 1 ifTrue: [^ model perform: keystrokeActionSelector with: aCharacter].
	args = 2 ifTrue: [^ model
			perform: keystrokeActionSelector
			with: aCharacter
			with: self].
	^ self error: 'The keystrokeActionSelector must be a 1- or 2-keyword symbol'! !


!String methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!UndefinedObject methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:42'!
hasNiceWrapper
	^ true! !

