'From Squeak3.1alpha of 7 March 2001 [latest update: #4173] on 31 July 2001 at 4:29:08 pm'!

!HandMorph methodsFor: '-- all --' stamp: 'fg 7/31/2001 12:05'!
attachMorph: m
	"Position the center of the given morph under this hand, then grab it.
	This method is used to grab far away or newly created morphs."
	| delta |
	m isMorph ifFalse: [^ self].
	m isWorldOrHandMorph ifTrue: [^ self].
	self releaseMouseFocus. "Break focus"
	delta _ m bounds extent // 8.
	m position: (self position - delta).
	m formerPosition: m position.
	targetOffset _ m position - self position.
	self addMorphBack: m.! !


!Preferences class methodsFor: 'initialization' stamp: 'fg 7/10/2001 22:05'!
addManualWindowPlacementPreference
	" 
	Preferences addManualWindowPlacementPreference 
	"
	self 
		addPreference: #manualWindowPlacement
		category: #windows
		default: true
		balloonHelp: 'If true, small windows are attached to the hand when they first appear'

! !

!Preferences class methodsFor: 'hard-coded prefs' stamp: 'fg 7/10/2001 22:13'!
maximumWindowArea
	"SystemWindows larger than this, wont be attached to the mouse"
	^  100000.0! !


!SystemWindow methodsFor: 'open/close' stamp: 'fg 7/14/2001 20:51'!
openInWorld: aWorld
	"This msg and its callees result in the window being activeOnlyOnTop"
	| rectangle |
	rectangle _ RealEstateAgent initialFrameFor: self world: aWorld.
	self bounds: rectangle.
	^ (rectangle area < Preferences maximumWindowArea and: [Preferences manualWindowPlacement])
		ifTrue: [aWorld primaryHand attachMorph: self]
		ifFalse: [self openAsIsIn: aWorld]! !

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

Preferences addManualWindowPlacementPreference !

