'From Squeak3.1alpha of 7 March 2001 [latest update: #4173] on 31 July 2001 at 3:16:19 pm'!

!EditableStringMorph methodsFor: 'event handling' stamp: 'fg 7/15/2001 00:38'!
keyStroke: evt 
	"Handle a keystroke event."
	| ch |
	ch _ evt keyCharacter.
	ch asciiValue = 1
		ifTrue: 
			[self home.
			^ self fitContents].
	ch asciiValue = 4
		ifTrue: 
			[self end.
			^ self fitContents].
	ch = Character backspace
		ifTrue: [evt shiftPressed
				ifTrue: [^ self del]
				ifFalse: [^ self backspace]].
	ch asciiValue = 127 ifTrue: [^ self del].
	ch asciiValue = 28
		ifTrue: 
			[self leftArrow.
			^ self fitContents].
	ch asciiValue = 29
		ifTrue: 
			[self rightArrow.
			^ self fitContents].
	(ch = $x and: [evt commandKeyPressed])
		ifTrue: 
			["cut"
			Clipboard clipboardText: contents.
			^ self contents: ''].
	(ch = $c and: [evt commandKeyPressed])
		ifTrue: 
			["copy"
			Clipboard clipboardText: contents.
			^ self].
	(ch = $v and: [evt commandKeyPressed])
		ifTrue: ["paste"
			^ self paste].
	(evt keyCharacter = Character enter
		or: [evt keyCharacter = Character cr
				or: [evt keyCharacter = $s and: [evt commandKeyPressed]]])
		ifTrue: 
			["accept"
			self acceptContents.
			evt hand keyboardFocus ifNil: [evt hand newKeyboardFocus: evt hand world].
			^ self].
	self addChar: ch!
]style[(14 599 9 121 9 422)f1b,f1,f1cred;,f1,f1cred;,f1! !

!EditableStringMorph methodsFor: 'editing' stamp: 'fg 6/30/2001 20:52'!
paste
	self contents: (contents insert: Clipboard clipboardText asString at: self cursor)! !


!PasteUpMorph methodsFor: 'aerial typing' stamp: 'fg 7/30/2001 12:19'!
bindings
	| newProperty |
	^ self
		valueOfProperty: #bindings
		ifAbsent: 
			[newProperty _ WeakValueDictionary new.
			self setProperty: #bindings toValue: newProperty.
			newProperty]! !

