'From Squeak3.1alpha of 7 March 2001 [latest update: #4173] on 1 August 2001 at 2:14:53 am'!

!MorphicWrapper class methodsFor: 'documentation' stamp: 'fg 7/31/2001 18:57'!
toDo
"

[Drag an Drop]

x Habilitar el DnD desde la lista de implementors, senders, etc. 

x Cambiar el DnD de las clases. Cuando se agarra deberia mostrarse como un string y recien adoptar la forma de ClassMorphicWrapper cuando se suelta.

- Habiliatar DnD desde el ObjectExplorer. Fijarse como lo hace el inspector.

- No funciona el DnD de metodos sobre clases (con SystemWindows).

[System Windows]
- Poner el menu especifico del MethodModel en la ventana (quizas agregando otro menu...)

- Cuando se abre una ventana de MethodModel attachado al hand (ie con manualWindowPlacemente en 'on'), el scrollbar no aparece. Para que aparezca hay que salir de la ventana y volver a posicionar el mouse arriba de ella. Suena que simplemente hay que mandarle un evento...

- Habilitar colores

[Object Explorer]
- El root del OE no cambia aunque cambie el objeto. Tambien seria bueno tener un ballon help con el nombre de la clase.

[ClassMorphicWrapper]

- El wrapper de una clase deberia tener una lista jerarquica como el ObjectExplorer. Esta lista seria asi:
	- MiClase
		- class definition
			- superclass
				- superclase inmediata
				:
				- Object
			- instance variables
				- inst var 1
				- inst var n
			- class variables
			- pool dictionaries
			- clas category
				- lista con todas las clases de la categoria
			- comment
			- subclasses
				- lista con todas las subclases
		- instance methods
			- accessing
				- method 1
					- versiones
						- ultima version 
						- primera version
					- changeSets 
				- method n
			- printing
				- printOn:
		- class methods
			- category 1
				- method 1
		- recent methods
			- method 1
			- method n

Inicialmente este pseudo ObjectExplorer se abre de un tamanio chico mostrando unicamente lo siguiente.
	- MiClase
		- class definition
		- instance methods
		- class methods
		- recent methods
A medida que se expanden las listas, el morph crece automaticamente hasta un maximo determinado.


- Cambiar el menu para que se muestre en dos etapas. Categorias y operaciones por otro.

- Agregar un boton (o un menu...) para seleccionar la cantidad de informacion a mostrar en un CMW. 

- Agregar preferencia para mostrar/ocultar el identityHash
"! !

!MorphicWrapper class methodsFor: 'documentation' stamp: 'fg 8/1/2001 02:13'!
versiones
"
[fg 7/16/2001 15:10] Primera Version
[fg 8/1/2001 02:01] Segunda Version

- MW-addOns
	- Aqui no toque nada

- MW-changesToBase
	- Elimine del changeset el metodo TransferMorph | #initDraggedMorph. Asi los morphs se arrancan con un string chiquito.

- MW-Fixes
	- Arregla el destinatario de #clipboardText
	- Se instalaba mal la property #bindings del mundo

- MW-MethodsInsideSystemWindows
	- Agrega dos preferencias. Una para decir si los metodos se ven dentro de SystemWindows o no, y otra para activar el efecto de carrying cuando los MW ingresan al mundo.
	- El carrying quedo desactivado porque ya no uso el metodo runAndAttachTo: 
	- Arregle el menu de los MethodModels 

- ManualWindowPlacement
	- Agrega una preferencia. Con la preferencia activada, las ventanas no muy grandes se pegan al mouse. 

- MW-ObjectExplorer-Extensions
	- Ahora se puede escribir en el aire, a los objetos que estan dentro de un ObjectExplorer. 
	- No hay que clickear para seleccionar el item. Esto sucede cuando el mouse esta encima del objeto. Le da un toque mas consistente con los MW

- MW-changesToBase-pancho.2
	- Un par de metodos para mi comodidad

- MW-DragAndDrop
	- Ahora es posible arrancar los metodos de listas de senders e implementors. Mejore un poco el mecanismo eliminado ifs.
	- Ahora se pueden agarrar los items de casi cualquier lista !!!!!! Browser, Debugger, ChangeSorter, ObjectExplorer, etc.
	- En cada modelo hay un solo metodo que controla cual el modelo para hacer el drag. Fijarse en #getItemAt:fromListNamed:. Tambien tuve que cambiar el #startDrag:. 
	- En todas las listas si se aprieta shift, se dragea la clase (en lugar del objeto).

"! !


!ObjectExplorer methodsFor: 'as yet unclassified' stamp: 'fg 7/31/2001 19:21'!
explorerFor: anObject insideMorph: owner
	| listMorph |
	rootObject _ anObject.
	owner addMorph: (listMorph _ SimpleHierarchicalListMorph 
			on: self
			list: #getList
			selected: #getCurrentSelection
			changeSelected: #noteNewSelection:
			menu: #genericMenu:
			keystroke: nil).
	listMorph autoDeselect: false.
! !

